linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
* [PATCH] scripts: prune-kernel : prune kernels generalized way
@ 2019-10-19 13:07 Bhaskar Chowdhury
  2019-10-19 16:01 ` J. Bruce Fields
  0 siblings, 1 reply; 9+ messages in thread
From: Bhaskar Chowdhury @ 2019-10-19 13:07 UTC (permalink / raw)
  To: yamada.masahiro, michal.lkml
  Cc: rdunlap, linux-kbuild, linux-kernel, bfields, Bhaskar Chowdhury

This patch will remove old kernel from the system in a selective way.

Signed-off-by: Bhaskar Chowdhury <unixbhaskar@gmail.com>
---
 scripts/prune-kernel | 86 ++++++++++++++++++++++++++++++++++++--------
 1 file changed, 72 insertions(+), 14 deletions(-)

diff --git a/scripts/prune-kernel b/scripts/prune-kernel
index e8aa940bc0a9..9d839a4e4539 100755
--- a/scripts/prune-kernel
+++ b/scripts/prune-kernel
@@ -5,17 +5,75 @@
 # again, /boot and /lib/modules/ eventually fill up.
 # Dumb script to purge that stuff:

-for f in "$@"
-do
-        if rpm -qf "/lib/modules/$f" >/dev/null; then
-                echo "keeping $f (installed from rpm)"
-        elif [ $(uname -r) = "$f" ]; then
-                echo "keeping $f (running kernel) "
-        else
-                echo "removing $f"
-                rm -f "/boot/initramfs-$f.img" "/boot/System.map-$f"
-                rm -f "/boot/vmlinuz-$f"   "/boot/config-$f"
-                rm -rf "/lib/modules/$f"
-                new-kernel-pkg --remove $f
-        fi
-done
+#for f in "$@"
+#do
+#       if rpm -qf "/lib/modules/$f" >/dev/null; then
+#                echo "keeping $f (installed from rpm)"
+#        elif [ $(uname -r) = "$f" ]; then
+#                echo "keeping $f (running kernel) "
+#        else
+#                echo "removing $f"
+#                rm -f "/boot/initramfs-$f.img" "/boot/System.map-$f"
+#                rm -f "/boot/vmlinuz-$f"   "/boot/config-$f"
+#                rm -rf "/lib/modules/$f"
+#                new-kernel-pkg --remove $f
+#       fi
+#done
+boot_dir=/boot
+modules_dir=/lib/modules
+
+function remove_old_kernel(){
+	cd $boot_dir
+	rm -If vmlinuz-$kernel_version System.map-$kernel_version config-$kernel_version
+}
+
+function remove_old_modules_dir(){
+	cd $modules_dir
+	rm -rf $modules_version
+}
+
+printf "\n\n Enlist the installed kernels \n\n"
+
+
+find $boot_dir -name "vmlinuz-*" -type f -exec ls -1 {} \;
+
+printf "\n\n\n Please give the kernel version to remove: %s"
+read kernel_version
+
+if [[ $kernel_version == "" ]];then
+	exit 1
+else
+	remove_old_kernel
+fi
+
+printf "\n\n Enlist the installed modules directory \n\n"
+
+find $modules_dir -maxdepth 0 -type d -exec ls -1 {} \;
+
+printf "\n\n Please give the full modules directory name to remove: %s"
+read modules_version
+
+if [[ $modules_version == "" ]];then
+	printf "You have forgotten to give the modules dir to remove"
+else
+	remove_old_modules_dir
+fi
+
+printf "\n\n\n Removed kernel version:$kernel_version and associated modules:$modules_version ...Done \n"
+
+while :
+ do
+    printf "\n\n Do you want to remove another?[YN]: %s"
+    read response
+       if [[ $response == "Y" ]];then
+	 printf "Please give another version to remove: %s"
+	 read kernel_version
+	 remove_old_kernel
+	 printf "Please give the full modules directory name to remove: %s"
+	 read modules_version
+	 remove_old_modules_dir
+	 printf "\n\n\n Removed kernel version:$kernel_version and associated modules:$modules_version ..Done \n\n"
+      elif [[ $response == "N" ]];then
+	 exit 1
+    fi
+ done
--
2.21.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread
* [PATCH] scripts : prune-kernel : prune kernels generalized way
@ 2019-10-17  6:31 Bhaskar Chowdhury
  2019-10-17 20:16 ` Randy Dunlap
  0 siblings, 1 reply; 9+ messages in thread
From: Bhaskar Chowdhury @ 2019-10-17  6:31 UTC (permalink / raw)
  To: yamada.masahiro, michal.lkml
  Cc: rdunlap, bfields, linux-kbuild, linux-kernel, Bhaskar Chowdhury

This patch will remove old kernel from the system in a selective way.

Signed-off-by: Bhaskar Chowdhury <unixbhaskar@gmail.com>
---
For Randy :
✔ ~/git-linux/linux-kbuild [master|AM/REBASE ↑·8|✔]
11:42 $ ./scripts/checkpatch.pl -f
scripts/0001-Fix-all-the-concern-raised-by-Randy.patch
total: 0 errors, 0 warnings, 93 lines checked

scripts/0001-Fix-all-the-concern-raised-by-Randy.patch has no obvious
style problems and is ready for submission.

scripts/prune-kernel | 75 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 75 insertions(+)

diff --git a/scripts/prune-kernel b/scripts/prune-kernel
index e69de29bb2d1..9461ae2bc122 100755
--- a/scripts/prune-kernel
+++ b/scripts/prune-kernel
@@ -0,0 +1,75 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+
+# because I use CONFIG_LOCALVERSION_AUTO, not the same version again and
+# again, /boot and /lib/modules/ eventually fill up.
+# Dumb script to purge that stuff:
+
+#for f in "$@"
+#do
+#        if rpm -qf "/lib/modules/$f" >/dev/null; then
+#                echo "keeping $f (installed from rpm)"
+#        elif [ $(uname -r) = "$f" ]; then
+#                echo "keeping $f (running kernel) "
+#        else
+#                echo "removing $f"
+#                rm -f "/boot/initramfs-$f.img" "/boot/System.map-$f"
+#                rm -f "/boot/vmlinuz-$f"   "/boot/config-$f"
+#                rm -rf "/lib/modules/$f"
+#                new-kernel-pkg --remove $f
+#        fi
+#done
+boot_dir=/boot
+modules_dir=/lib/modules
+function remove_old_kernel(){
+	cd $boot_dir
+	rm -If vmlinuz-$kernel_version System.map-$kernel_version config-$kernel_verison
+}
+function remove_old_kernel_modules_dir(){
+	cd $modules_dir
+	rm -rf $modules_version
+}
+printf "\n\n Enlist the installed kernels \n\n"
+
+find $boot_dir -name "vmlinuz-*" -type f  -exec ls -1 {} \;
+
+printf "\n\n\n Please give the kernel version to remove: %s"
+read kernel_version
+if [[ $kernel_version -eq "" ]];then
+	printf "You have forgotten the version to give for removal"
+	exit 1
+else
+        remove_old_kernel
+fi
+
+printf "\n\n Enlist the installed modules directory \n\n"
+
+find $modules_dir  -maxdepth 0 -type d -exec ls -1 {} \;
+
+printf "\n\n Please give the full modules directory name to remove: %s"
+read modules_version
+if [[ $modules_version -eq "" ]];then
+	printf "You have forgotten to give the modules dir to remove"
+else
+        remove_old_kernel_modules_dir
+fi
+
+printf "\n\n Removed kernel version: $kernel_version and associated modules: $modules_version ...Done \n"
+while :
+  do
+     printf "\n\n Do you want to remove another?[YN] : %s"
+     read response
+
+       if [[ $response == "Y" ]];then
+	printf "Please give another version to remove : %s"
+	read kernel_version
+	remove_old_kernel
+	printf "\n\n Please give the full modules directory name to remove: %s"
+	read modules_version
+	remove_old_kernel_modules_dir
+        printf "\n\n Removed kernel version: $kernel_version and associated modules: $modules_version ...Done \n"
+
+      elif [[ $response == "N" ]];then
+	   exit 1
+      fi
+  done
--
2.21.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread
* [PATCH] scripts : prune-kernel : prune kernels generalized way
@ 2019-10-16  6:13 Bhaskar Chowdhury
  2019-10-16 16:08 ` Randy Dunlap
  0 siblings, 1 reply; 9+ messages in thread
From: Bhaskar Chowdhury @ 2019-10-16  6:13 UTC (permalink / raw)
  To: yamada.masahiro, michal.lkml
  Cc: linux-kbuild, linux-kernel, rdunlap, bfields, Bhaskar Chowdhury

This patch will remove old kernel from the system in a selective way.

Signed-off-by: Bhaskar Chowdhury <unixbhaskar@gmail.com>
---
Thanks, a bunch to Randy for the hand holding . :)

 scripts/prune-kernel | 71 ++++++++++++++++++++++++++++++++++++--------
 1 file changed, 59 insertions(+), 12 deletions(-)

diff --git a/scripts/prune-kernel b/scripts/prune-kernel
index e8aa940bc0a9..78dd4c854b2b 100755
--- a/scripts/prune-kernel
+++ b/scripts/prune-kernel
@@ -5,17 +5,64 @@
 # again, /boot and /lib/modules/ eventually fill up.
 # Dumb script to purge that stuff:

+#for f in "$@"
+#do
+#        if rpm -qf "/lib/modules/$f" >/dev/null; then
+#                echo "keeping $f (installed from rpm)"
+#        elif [ $(uname -r) = "$f" ]; then
+#                echo "keeping $f (running kernel) "
+#        else
+#                echo "removing $f"
+#                rm -f "/boot/initramfs-$f.img" "/boot/System.map-$f"
+#                rm -f "/boot/vmlinuz-$f"   "/boot/config-$f"
+#                rm -rf "/lib/modules/$f"
+#                new-kernel-pkg --remove $f
+#        fi
+#done
+boot_dir=/boot
+modules_dir=/lib/modules
+
+function remove_old_kernel(){
+	cd $boot_dir
+	rm -If vmlinuz-$kenrel_version System.map-$kernel_version config-$kernel_verison
+}
+function remove_old_kernel_modules_dir(){
+	cd $modules_dir
+	rm -rf $modules_version
+}
+printf "\n\n Enlist the installed kernels \n\n"
+
+find $boot_dir -name "vmlinuz-*" -type f  -exec ls -1 {} \;
+
+printf "\n\n\n Please give the kernel version to remove: %s"
+read kernel_version
+
+remove_old_kernel
+
+printf "\n\n Enlist the installed modules directory \n\n"
+
+find $modules_dir  -maxdepth 0 -type d -exec ls -1 {} \;
+
+printf "\n\n Please give the full modules directory name to remove: %s"
+read modules_version
+
+remove_old_kernel_modules_dir
+
+printf "\n\n Removed kernel version: $kernel_version and associcated modules: $modules_version ...Done \n"
+while :
 do
+printf "\n\n Do you want to remove another?[YN] : %s"
+read response
+
+if [[ $response == "Y" ]];then
+	printf "Please give another version to remove : %s"
+	read kernel_version
+	remove_old_kernel
+	printf "\n\n Please give the full modules directory name to remove: %s"
+	read modules_version
+	remove_old_kernel_modules_dir
+elif [[ $response == "N" ]];then
+	printf "\n\n Alright,no more. \n\n"
+	exit 1
+fi
 done
--
2.21.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread

end of thread, other threads:[~2019-10-19 22:16 UTC | newest]

Thread overview: 9+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2019-10-19 13:07 [PATCH] scripts: prune-kernel : prune kernels generalized way Bhaskar Chowdhury
2019-10-19 16:01 ` J. Bruce Fields
2019-10-19 22:16   ` Bhaskar Chowdhury
  -- strict thread matches above, loose matches on Subject: below --
2019-10-17  6:31 [PATCH] scripts : " Bhaskar Chowdhury
2019-10-17 20:16 ` Randy Dunlap
2019-10-17 23:00   ` Bhaskar Chowdhury
2019-10-16  6:13 Bhaskar Chowdhury
2019-10-16 16:08 ` Randy Dunlap
2019-10-17  6:19   ` Bhaskar Chowdhury

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).